#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
#include "System.h"
using namespace std;
#include "e0g-pqe+.hh"
#include "einline.hh"


/*==============================

  U P D A T E _ V A R _ M O D E

 ===============================*/
void ExQuant::update_var_mode()
{
  if ((num_act_sgnl_cubes == 0) && (num_assgn_xvars == 0))
    yvar_mode = true;
  else    {
    if (curr_depth == -1) return;
    Node &n = Tree_path[curr_depth];
    if ((alg_state != BPE) && (Var_state[n.var-1].xvar == 0))	{
      p();
      printf("gcount = %ld\n",gcount);
      print_alg_state(false);
      printf("num_assgn_xvars = %d\n",num_assgn_xvars);
      printf("real number of assigned int vars = %d\n",real_num_assgn_int_vars());     
      printf("num_act_sgnl_cubes = %d\n",num_act_sgnl_cubes);
      printf("init_ncubes = %d\n",init_ncubes);
      print_sgnl_cubes(true);
      exit(ERROR);
    }
  }
} /* end of function update_var_mode */


