int ds_pqe();
void form_result(DNF &F);
void opt_result(DNF &Res,DNF &F,double Run_time);
void check_yvars();
bool check_init_sgnl_cubes();
void initialize(void);
BCPreturn  run_bcp(void);
int  proc_unit_X_cubes(DNF &Res);
AlgState dec_making_state_xvar();
AlgState dec_making_state_yvar();
AlgState bcp_state();
AlgState bpe_state(CUBE &Recov_act_cubes);
AlgState backtrack_state_xvar();
AlgState backtrack_state_yvar();
AlgState bcp_cnfl_state(CUBE &Recov_act_cubes); 
AlgState bpe_cnfl_state();
AlgState loc_bcktr_state(CUBE &Late_cubes);

//
//
//

void print_version();
void build_form(Msolver *Slvr,int cube_ind);
void update_sat_ycubes(CUBE &Cubes);
void print_xvar_dec_mode();
void print_yvar_dec_mode();
void init_sgnl_cubes(int cube_ind);
int check_cubes(CUBE &Cubes);
int find_act_sgnl_cube();
int find_max_propag();
void form_assumps1(MvecLits &Assmps,Msolver *Aux_slv);
void upd_prim_cubes_info(int cube_ind);
void mark_glob_red(int cube_ind);
void add_cause_lit(CUBE &B,int cube_ind);
void upd_prim_sgnl_cubes();
void print_header();
void read_parameters(int argc,char *argv[]);
void delete_tree();
int find_bp_assgn();
void fill_yas(Msolver *Slv);
void  form_blocking_clause(CLAUSE &B,int cube_ind);
void  loc_init(CUBE &B,int cube_ind);
void print_stat1();
bool eg_pqe_plus();
bool init();
void read_input(char *root);
void extr_y_assgns(CUBE &Ya,Msolver *Aux_slv);
void reduce_y_assgns(SCUBE &Ya,CUBE &A);
bool mandatory(CUBE &A,int assgn,SCUBE &Ya,int cls_ind);
bool blocking_clause(CLAUSE &B,int cube_ind);
bool check_time();
bool prove_red(int cube_ind);
void gen_impl_cls(CLAUSE &D,MvecLits &Assmps);
void form_sat_assgn(CUBE &A,Msolver *Solver);
void add_sat_xlit(CLAUSE &B,CLAUSE &C);

//
//
int find_sgnl_xvar_assgn();
int find_xvar_assgn1();
int find_xvar_assgn2();
int triv_xvar_assgn();
void init_queue_impl_assgn(Node &n);
void init_queue_dec_assgn(Node &n);
void init_assgn_queue(int cube_num, int assgn);
bool Xcube(CUBE &C);
int max_cube_recovery_depth(CUBE &S);
//
 
void check_red_cube_in(int cube_ind,int lit,int rec_depth,bool recompute_scores);
void recover_active_cube(int cube_ind); 
 
//
int  make_one_assignment(int assgn,CUBE &removal_array,CUBE &sat_array);
int find_length(CUBE &C,int &assgn);
void create_node(int unit_cube_num,int assgn);
void make_node_assgn(int assgn);
void delete_node(int &curr_depth);
void unassign_var(int depth); 
void unassign_var(Node &n);

void recover_vars_act_cubes(int curr_depth);
void flip_branch(Node &n);
void assign_empty_cube_to_node(int empty_cube_depth,int empty_cube_index);;
void gen_resolvent(CUBE &C,Node &n);
void add_cube(CUBE &C,int sgnl_cube_depth,bool clean,bool glb_sgnl);
void assign_variables(int var_ind0);
void add_new_literals(CUBE &E,CUBE &C);
 
  
//
//
void seq_gen_red_cube1(CUBE &S,int lit_ind);
void seq_gen_red_cube2(CUBE &S,int cube_ind,int lit_ind);
void seq_gen_ecube(Node &n);
void seq_gen_one_polarity(CUBE &S,CUBE &Cubes);
void insert_into_table(int var_ind,int lit);
bool present_in_table(int var_ind, int lit);
void copy_lits(CUBE &toS,CUBE &fromS);
void set_new_act_dseq(int cube_ind,CUBE &S,bool replace,DseqType type);
void add_lit_presence(int cube_ind,CUBE &S);
void update_lit_presence(int cube_ind,int lit,CUBE &oldS,CUBE &newS);
void remove_lit_presence(int cubeind);
//
//
bool update_dseqs_vars_cubes(Node &n);
void  form_left_red_cubes(Node &n,CUBE &Media_cubes);
void discard_dseqs(CUBE &Media_cubes);
void recover_active_cubes1(CUBE &Cubes,CUBE &Cubes_to_exclude);
void recover_active_cubes(CUBE &Cubes,CUBE &Cubes_to_protect);
void recover_sat_sgnl_cubes(CUBE &Cubes);
void recover_sat_media_cubes();
void recover_sat_cubes(CUBE &Cubes_to_protect);
bool contains_red_var(CUBE &C,int &var_ind);
void join_dseqs(Node &n);
bool resolve(CUBE &Res,CUBE &C1,CUBE &C2,int var); 
void join_unsat_sat(Node &n);
void join_sat_unsat(Node &n,CUBE &Old_protecting_cubes);
void join_sat_sat(Node &n);
void find_candidate_red_cubes(CUBE &Red_cube_inds,CubeMap &Cube_inds);
bool active_sequent(CUBE &S,bool &red_var);
void print_seq_lit_relation();
CubeType cube_type_check(CUBE &C);
int value(int var_ind);
int assigned(int var_ind);
bool cnfl_node(Node &n);
int fnd_cnfl_jmp_dpth(int starting_depth);
int fnd_ecube_dpth(CUBE &E);
void drop_node(int &curr_depth);
void undo_red_cubes(Node &n,CUBE &Cubes_to_protect); 
void gen_cnfl_cube(CUBE &E,int &confl_jump_depth,int &sgnl_cube_depth,
                   bool &clean,bool &glb_sgnl);
void find_red_cubes_to_update(CUBE &Vars, Node &n);
void update_vars_cubes(Node &n,CUBE &Cubes_to_protect);
void print_stat();
void print_info(int final_size);
void rem_old_left_dseqs(int red_var_ind,int branch_var);
void finish_update_left_dseqs(int red_var_ind); 
int xvar_check(int var_ind);
int xvar_check(Node &n);
void decrease_sgnl_cube_scores(int cube_ind);
void increase_sgnl_cube_scores(int cube_ind);
void check_sat_cube_in(int cube_ind,int assgn);
void set_init_counts();
int num_sgnl_cubes(CUBE &Cubes);
void update_var_mode();
bool yvar_node(int depth);
void form_unit_xcube_queue();
void form_unit_ycube_queue();
bool unit_cube_assgn_xvar();
bool unit_cube_assgn_yvar();
void create_impl_var_node(int cube_ind, int assgn);
void init_solver_state();
void update_lit_activity(CUBE &S);
void update_lit_activity(CUBE &S,int cube_ind);
void decrease_lit_activity();
void print_solver_state();
void switch_into_xvar_mode();
void update_last_cnfl_cubes();
void form_cubes(CUBE &Res_cubes,CUBE &Cand_Cubes,CUBE &Range);
bool form_cubes(CUBE &Res_cubes,CUBE &Range,CUBE &Cand_cubes,int num_cubes_to_resolve,int thresh);
bool form_cubes1(CUBE &Res_cubes,CUBE &Cand_cubes,CUBE &Range);
bool form_cubes2(CUBE &Res_cubes, CUBE &Cand_cubes,int factor, int thresh);
int  compute_jump();
long int  total_num_res_dseqs();
int act_sgnl_cubes_cnt(int var_ind);
bool red_xvar(int var_ind);
bool assgn_init_prot_cubes(); 
int  distance(CUBE &C1,CUBE &C2);
bool fnd_ping_cubes(int cube_ind,int &lit);
int  fnd_one_ping_cube(CUBE &C,CUBE &Cube_inds,int &max_depth);
int  fnd_one_ping_cube1(CUBE &C,CUBE &Cube_inds,int depth,int &max_depth);
void update_prot_cube_info(int cube_ind,int lit_ind,int ping_cube_ind);
void check_for_new_red_cubes(CUBE &Red_cubes); 
void check_for_new_red_cubes1(CUBE &Red_cubes); 
bool protect_one_cube_lit(int cube_ind,int lit_ind);
void extract_pair(int &cube_ind2,int &lit_ind2,int cube_ind1);
void find_new_protection(CUBE &Red_cubes,int cube_ind); 
void find_new_protection1(CUBE &Red_cubes,int cube_ind); 
void add_s_sequents_dec_node(int assgn);
void add_s_sequents_impl_node(Node &n);
Node& var_node(int var_ind);
void  proc_cubes_sat_rbranch(Node &n);
bool recover_protection(int cube_ind,int curr_depth,int &min_depth_lit,int &min_depth);
void form_init_prot_cubes(); 
int find_resolvable_cube(CUBE &C,CUBE &Cubes);
BranchType branch_type(int var_ind);  
bool falsified_branch(int var_ind,BranchType branch); 
void check_red_cube_out(int cube_ind);
void confirm_active_cubes(CUBE &Cubes,CUBE &Red_cubes,int depth);
void confirm_active_cubes1(CUBE &Cubes,CUBE &Red_cubes,int depth); 
void finish_proc_sat_cubes();
int estimate(CUBE &C);
void squeeze_Ped(int cube_ind);
bool already_protected(int cube_ind,int lit_ind);
void mark_sat_cubes(CUBE &Cubes);
void recover_prot_cubes(CUBE &Cubes_to_protect,int confl_jump_depth); 
void recover_prot_cubes(Node &n,CUBE &Cubes_to_protect,int confl_jump_depth);
void add_cubes_to_protect(CUBE &Cubes_to_protect,CUBE &Unassgn_lits);
void add_unassgn_literal(CUBE &Unassgn_lits);
Node &curr_node();
long int num_blocked_cube_dseqs();
void compute_late_cubes(Node &n,CUBE &Late_cubes);
void proc_late_cubes(Node &n,CUBE &Sat_late_cubes);
void new_late_cubes(Node &n,CUBE &Recov_act_cubes,CUBE &Late_cubes);
void make_cubes_red(Node &n,CUBE &Late_cubes);
void squeeze_vars(CUBE &Vars);
void add_xvar_to_array(int var_ind);
void rem_xvar_from_array();
bool int_arr_sqz_cond();
void add_yvar_to_array(int var_ind);
void rem_yvar_from_array(int var_ind);
bool yvar_arr_sqz_cond();
void add_bcp_sgnl_cubes(int assgn,int depth);
void set_new_sgnl_cube(int cube_ind,int depth);
void confirm_sgnl_cubes(CUBE &Cubes,CUBE &Red_cubes,int depth);
void revoke_sgnl_status();
bool check_spec_cond(Node &n);
void print_sgnl_status(int cube_ind,bool depth_flag = false,int shift=0);
void set_correct_cube_state(int cube_ind);
void rem_sgnl_ycubes();
void proc_missed_cubes(Node &n);
void rem_wrong_yvars();
int levelize_new_cubes(CUBE &Levels);
int rand_xvar_assgn();
int active_cube_count(CUBE &Cubes);
bool resource_exceeded(long int gcount);
void print_prepr_results1();
void print_prepr_results2();
void print_out_array(char *fname,CUBE &Vars);
void form_Xvars_Yvars();
bool missing_var(int var_ind);
